.386
.model flat,stdcall
option casemap:none

include          windows.inc
include          gdi32.inc
includelib       gdi32.lib
include          user32.inc
includelib       user32.lib
include          kernel32.inc
includelib       kernel32.lib
include comctl32.inc
includelib comctl32.lib
include macro.asm

.data?
hInstance		dd ?
hBit			dd ?
hImageList		dd ?
hWinMain		dd ?

.const
title1		db		'font',0
className	db		'wndclass',0
outText		db		'HOVERLEES!!!(:>) LOL########',0
fTable 		db		'!"#$% `()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]',0
.code

DrawFontTest	proc uses esi,hdc:DWORD,hImageListp:DWORD,lpText:DWORD,xpos:DWORD,ypos:DWORD
		local paintX,paintY,counter
		local tempChar:BYTE
		push xpos
		pop paintX
		push ypos
		pop paintY
		cld
		mov counter,0
		mov esi,lpText
		lodsb
		mov tempChar,al
		.while tempChar!=0
			mov edi,offset fTable
			assume edi:ptr BYTE
			mov counter,0
			.while TRUE
				.break .if [edi]==0
				mov al,tempChar
				.break .if [edi]==al
				inc counter
				inc edi
			.endw
			.if [edi]==0
				mov counter,-1
			.endif
			invoke ImageList_Draw,hImageListp,counter,hdc,paintX,paintY,ILD_NORMAL
			add paintX,8
			lodsb
			mov tempChar,al
		.endw
ret
DrawFontTest	endp

_PWM1		proc	uses ebx edi esi,hWnd,uMsg,wParam,lParam
		local ps:PAINTSTRUCT
		local rt:RECT
		local hdc
		local paintX,paintY
		mov eax,uMsg
		.if eax==WM_CREATE
			invoke LoadImage,hInstance,CTXT("./font3.bmp"),IMAGE_BITMAP,488,13,LR_LOADFROMFILE
			mov hBit,eax
			invoke ImageList_Create,8,13,ILC_COLOR24,61,10
			mov hImageList,eax
			invoke ImageList_Add,hImageList,hBit,NULL
		.elseif eax==WM_PAINT
			invoke BeginPaint,hWnd,addr ps
			mov hdc,eax
			invoke DrawFontTest,hdc,hImageList,offset outText,20,100
			invoke EndPaint,hWnd,addr ps
		.elseif eax==WM_CLOSE
			invoke	ImageList_Destroy,hImageList
			invoke	DeleteObject,hBit
			invoke	DestroyWindow,hWinMain
			invoke	PostQuitMessage,NULL
		.else
			invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		.endif
		ret
_PWM1 endp

_WMain proc
		local hover:WNDCLASSEX
		local hmsg:MSG
		invoke GetModuleHandle,NULL
		mov hInstance,eax
		invoke RtlZeroMemory,addr hover,sizeof hover
		invoke LoadCursor,NULL,IDC_ARROW
		mov hover.hCursor,eax
		push hInstance
		pop hover.hInstance
		mov hover.cbSize,sizeof WNDCLASSEX
		mov hover.hbrBackground,COLOR_WINDOW+1
		mov hover.lpfnWndProc,offset _PWM1
		mov hover.style,CS_HREDRAW or CS_VREDRAW
		mov hover.lpszClassName,offset className
		invoke RegisterClassEx,addr hover
		invoke CreateWindowEx,WS_EX_APPWINDOW,\
		offset className,offset title1,\
		WS_OVERLAPPEDWINDOW,\
		CW_USEDEFAULT,CW_USEDEFAULT,400,400,\
		NULL,NULL,hInstance,NULL
		mov hWinMain,eax
		invoke ShowWindow,hWinMain,SW_SHOWDEFAULT
		invoke UpdateWindow,hWinMain
		.while TRUE
			invoke GetMessage,addr hmsg,NULL,0,0
			.break .if eax==0
			invoke TranslateMessage,addr hmsg
			invoke DispatchMessage,addr hmsg
		.endw
		ret
_WMain endp
start:
		call _WMain
		invoke ExitProcess,NULL
end start